#!/usr/bin/env python
import random
import time
import numpy as np
from collections import defaultdict
from csv import DictReader
import os

from schedcat.util.storage import storage
# from generator.generator import DesignPointGenerator

from distributions import *

# from schedcat.model.LLC_params import *
from schedcat.generator.mcx_tasks import TaskGeneratorMCX
import schedcat.model.ohc as ohc
import loadohs
import schedcat.model.mcx_tasks as ts

from sched_check import *



def main():
    loadohs.load("../oheads/")
    
    datadir = "./casestudyts/"
    
    total_count = 0

    schedUs = []

    for filename in os.listdir(os.getcwd() + "/" + datadir):
#         filename = "ts2_3.txt"
        d = DictReader(open(datadir + filename, 'r'))
        data = defaultdict(list)
        for row in d:
            for key, value in row.iteritems():
                data[key].append(value if value != "None" else '1024')
        
        tasks = []
        
        for i in range(0, len(data['#name'])):
            costs = dict()
            costs['A'] = [[0 for w in range(0, 17)] for s in range(0, 17)]
            costs['B'] = [[0 for w in range(0, 17)] for s in range(0, 17)]
            costs['C'] = [[0 for w in range(0, 17)] for s in range(0, 17)]
            
            level = None
            
#             print str(i) + ", " + str(len(data['#name'])) + ", " + str(len(data[' crit_lv']))
            if data[' crit_lv'][i] == '0':
                costs['A'][4][8] = 1000*float(data[' WCET_A'][i])
                costs['B'][4][8] = 1000*float(data[' WCET_B'][i])
                costs['C'][4][8] = 1000*float(data[' WCET_C'][i])
                level = 'A'
            if data[' crit_lv'][i] == '1':
                costs['B'][4][8] = 1000*float(data[' WCET_B'][i])
                costs['C'][4][8] = 1000*float(data[' WCET_C'][i])
                level = 'B'
            if data[' crit_lv'][i] == '2':
                costs['C'][16][8] = 1000*float(data[' WCET_C'][i])
                level = 'C'
            
            period = 1000*float(data[' PERIOD'][i])
            
#             print data[' WSS'][i] + ", " + str(i) + ", " + str(len(data[' WSS']))
            wss = float(data[' WSS'][i])/4.0
            
            deadline = period
            
            tsk = ts.SporadicTaskMCX(exec_cost = costs, period = period, wss = wss, level = level, deadline = deadline)
            
            tsk.core = int(data[' cpu'][i])
            
            tasks.append(tsk)
            
            # break
        
        ts_mcx = ts.TaskSystemMCX(tasks)
        ts_mcx.a_inflate_choice = 1.5
        
#         ts.setLLCAlloc(bypass_scheme())
        ohc.SetOheads(ts_mcx, 'mc2') 
        Ures = is_sched(ts_mcx, default_share_scheme(), debug = True, inflated = True)
        if Ures != None:
            schedUs.append([filename, Ures])

        
#         print filename
#         print "is schedulable? : " + str(is_sched(ts_mcx, default_share_scheme(), debug = True, inflated = True))    
        
    schedUs.sort(key=lambda P: P[1]['C'])
    
    for file, u in schedUs:
        print file + ": " + str(u)

                        
if __name__ == '__main__':
    main()