#!/usr/bin/env python

from os import listdir
import sys
import re
import os
from Cheetah.Template import Template

FIGTEX = """
\includegraphics[width=\columnwidth]{sched_online/$file}
\captionof*{figure}{$util_dist, $period, $task_util, $memory_util, $ipc_size, $bandwidth, $copy_dist}
\\vspace{0.2in}"""

# FIGTEXH = """
# \includegraphics[width=\columnwidth]{histos/$file}
# \captionof*{figure}{$util_dist, $period, $task_util, $wss}
# \\vspace{0.2in}"""

FIGS_PER_PAGE = 8


def main():
    parameters = ["util_dist",
                  "period",
                  "task_util",
                  "memory_util",
                  "bandwidth",
                  "ipc_size",
		  "copy_dist"]
                  
    dist_conv = {   'util_Alight_Blight_Cheavy':'C-Heavy', 
                    'util_Amod_Bmod_Clight':'C-Light',
                    'util_Amod_Bmod_Cmod':'All-Mod.',
                    
                    'period_medium':'Short', 
                    'period_realistic':'Med.', 
                    'period_long':'Long',
                    
                    'wss-heavy':'Slow', #How to handle wss?
                    'wss-light':'Quick',
                    
                    'sens_regular'  :'Reg.',

			'message_large':'Large',
			'message_small':'Small',

			'band_low':'Low',
			'band_mod':'Med.',
                        'band_high':'High',

			'lightweight':'Light',
			'modweight':'Med.',
			'heavyweight':'Heavy',

			'copy_heavy':'Few',
			'copy_light':'Many',

                    }
                  
    outpdf = open("sched-app-plots.tex", 'w')
    filenamegroup = []
    for j, filenameiter in enumerate(os.listdir(os.getcwd() + "/../plots_refined/pdfs/")):
        filenamegroup.append(filenameiter)
        if len(filenamegroup) == 8:
            texgroupsched = []
            for filename in filenamegroup:
                splits = []
                splits.append(-2)
                for i in range(0, len(filename)-1):
                    if filename[i] + filename[i+1] == '--':
                        splits.append(i)
                namespace = dict()
        
                splits.append(len(filename)-4)
                for i in range(0, len(splits)-1):
                    namespace[parameters[i]] = filename[(splits[i]+2):splits[i+1]]
                #print namespace
                for key in namespace:
                    namespace[key] = dist_conv[namespace[key]]
                namespace["file"] = filename
                #print namespace
                texgroupsched.append(Template(FIGTEX, searchList = namespace))
            
            outpdf.write("\clearpage\n\\begin{minipage}{\\textwidth}\n\\centering\n")
            
            outpdf.write("\n\\begin{minipage}{0.45\\columnwidth}\n\\centering\n")
            for i in range(0,4):
		#print texgroupsched[i]
                outpdf.write(str(texgroupsched[i]))
            outpdf.write("\n\\end{minipage}")
            outpdf.write("\\hspace{0.2in}")
            outpdf.write("\n\\begin{minipage}{0.45\\columnwidth}\n\\centering\n")
            for i in range(4,len(texgroupsched)):
                outpdf.write(str(texgroupsched[i]))
            outpdf.write("\n\\end{minipage}\n")
            
            outpdf.write("\n\\end{minipage}\n")
            filenamegroup = []
    outpdf.close()

if __name__ == '__main__':
    main()

