#!/usr/bin/env python
import random
import networkx as nx

class shqueue():
    def __init__(self, writer, reader):
        self.R = reader
        self.W = writer
    
def add_cross_crit_buffers(ts):
    #random graph with node per task and each potential edge has probability 0.1
    G = nx.gnp_random_graph(len(ts), 0.1, directed=True)
    
    
    
    buffers = []
    
    toRemove = 0
    for i, edge in enumerate(G.edges()):
        if not (ts[edge[0]].level == ts[edge[1]].level):
            buffers.append(shqueue(ts[edge[0]], ts[edge[1]]))
            
#             ts[edge[0]].W.append(buffers[len(buffers)-1])
#             ts[edge[1]].R.append(buffers[len(buffers)-1])
    
    #assume some small fraction of buffers are cross crit
    #wfcount upper bounds number of cross crit buffers
    wfcount = .2*len(ts.buffers)
    
    #while loop removes cross crit buffers until under wfcount
    while len(buffers) > wfcount:
        removeNDX = int(len(buffers)*random.random()) 
        if removeNDX == len(buffers):
            removeNDX -= 1
            
        del buffers[removeNDX]
          
    for buff in buffers:
        buff.R.R.append(buff)
        buff.W.W.append(buff)
        
    ts.buffers.extend(buffers)
    
#     ts.buffersH.extend([buffer for buffer in buffers if not (buffer.W.level == 'C' or buffer.R.level == 'C')])
    
    
    
