from schedcat.generator.tasks import uniform_int, uniform, exponential, multimodal, uniform_choice
import schedcat.generator.tasks as tasks
from schedcat.model.LLCLayout import *
import graph

def bypass_scheme():
    AB = area(0, 4)
    C = area(16, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

def default_scheme():
    AB = area(4, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def wba_fixed_scheme():
    AB = area(2, 16)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def default_share_scheme():
    AB = area(8, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)    

def pedf_scheme():
    A = area(0, 0)
    B = area(16, 4)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def uni_scheme():
    A = area(0, 0)
    B = area(16, 16)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def c_iso_scheme():
    AB = area(4, 4)
    C = area(8, 4)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

#50-70 to #80-100
#20-40 to #30-60
def AVG_PERCENT(bkgrnd_load, level):
    min1, min2, max1, max2 = (0, 0, 0, 0)
    if level is 'A' or level is 'B':
        min1, max1, min2, max2 = {0.5, 0.7, 0.8, 1.0}
    elif level is 'C':
        min1, max1, min2, max2 = {0.2, 0.4, 0.3, 0.6}
    else:
        print "\n error in distributions, line 30 \n"
    
    bary = min(1.0, bkgrnd_load/4.0)
    
    tskmin = min1 + bary*(min2-min1)
    tskmax = max1 + bary*(max2-max1)
    
    return uniform(tskmin, tskmax)()

unmanwt = uniform(1.1,1.3) #uniform(1.0, 1.3)
loadedinfAB = uniform(1.2, 1.5) 
loadedinfC = uniform(1.2, 1.5) 

CORES = 4
#CORES = 3

dlight = uniform(0.1, 0.3)
dmoder = uniform(0.35, 0.45)
dheavy = uniform(0.5, 0.7)


NAMED_UTIL_DISTS = {
    'util_Amod_Bmod_Clight'  : {'A' : dmoder, 'B' : dmoder, 'C' : dlight},
    'util_Alight_Blight_Cheavy'    : {'A' : dlight, 'B' : dlight, 'C' : dheavy},
    'util_Amod_Bmod_Cmod' : {'A' : dmoder, 'B' : dmoder, 'C' : dmoder}
}

NAMED_PERIODS = {
    'period_medium'      : {'A' : uniform_choice([12000, 24000]), 'B' : uniform_choice([24000, 48000]), 'C' : uniform_int(12000,  100000)},
    'period_realistic'	: {'A':	uniform_choice([20*1000, 40*1000]), 'B': uniform_choice([40*1000, 80*1000]), 'C': uniform_int(20*1000, 100*1000)},
    'period_long'        : {'A' : uniform_choice([48000, 96000]), 'B' : uniform_choice([96000, 192000]), 'C' : uniform_int(50000, 500000)},
}

NAMED_UTILIZATIONS = {
    'lightweight'     : {'A' : uniform(0.001, 0.03), 'B' : uniform(0.001, 0.05), 'C' : uniform(0.001, 0.1)},
    'modweight'    : {'A' : uniform( 0.02, 0.1), 'B' : uniform( 0.05, 0.2), 'C' : uniform(  0.1, 0.4)},
    'heavyweight'     : {'A' : uniform(  0.1, 0.2), 'B' : uniform( 0.2, 0.4), 'C' : uniform(  0.4, 0.6)},
}

NAMED_MEMORY = {
    'wss-light'           : uniform(0.01, 0.1),
    'wss-heavy'           : uniform(0.25, 0.5),
}

NAMED_NUM_GRAPHS = {
    'graph_uni_large'	:	graph.uniform(10,15),
}


#in bytes
NAMED_IPC_SIZES = {
	'message_large'	:	uniform_choice([4096, 8192]),
	'message_small'	:	uniform_choice([256,	128]),
}

NAMED_COPY_DIST = {
	'copy_heavy'	:	uniform(0.0, 0.3),
	'copy_light'	:	uniform(0.7, 0.99),
}

NAMED_BANDWIDTHS = {
	'band_low'	:	uniform(0,20),
	'band_mod'	:	uniform(40, 60),
	'band_high'	:	uniform(180, 200)
}

#Graph generation parameters
NAMED_HEIGHT_FACTORS = {
    'combined'   : [1.0/3.0, 1.0],
}

NAMED_SHAPES = {
    'binomial' : graph.binomial(),
}

NAMED_FAN = {
    'uniform_3'   : graph.uniform(1,3),
}

NAMED_EDGE_HOP = {
    'none'       : graph.uniform(1,1),
}

class Custom:
    pass

PAB = Custom()
PAB.ks = uniform(0.01, 0.05)
#PAB.kw = uniform(0.01, 0.02)
#PAB.kp = uniform(0.025, 0.75)
PAB.kmin = uniform(0.4, 0.8)
PAB.infMax = uniform(0.5, 0.6)
PAB.aMax = uniform(0.03, 0.05)
PAB.decay = uniform(0.005, 0.01)
PAB.way_ind = uniform(0.1, 0.2)
PAB.c_scale = uniform(0.8, 1.0)
PAB.c_shared = uniform(0.3,0.7)

PAC = Custom()
PAC.ks = uniform(0.005, 0.03)
#PAC.kw = uniform(0.01, 0.02)
#PAC.kp = uniform(0.025, 0.75)
PAC.kmin = uniform(0.4, 0.8)
PAC.infMax = uniform(0.5, 0.6)
PAC.aMax = uniform(0.03, 0.05)
PAC.decay = uniform(0.005, 0.01)
PAC.way_ind = uniform(0.1, 0.2)
PAC.c_scale = uniform(0.8, 1.0)
PAC.c_shared = uniform(0.3,0.7)

P = {
    'A': {'A': PAB},
    'B': {'A': PAB},
    'C': {'A': PAC}
}

redfunc = uniform(0, 0.05)
