#!/usr/bin/env python

from __future__ import division

import os
import numpy as np
import argparse
from collections import defaultdict

from schedcat.util.storage import storage
from generator.generator import DesignPointGenerator

from distributions import *

def myrange(start, end, inc):
    return np.arange(start, end+inc, inc)

def titlefor(headers):
    return headers['util_dist'] + "--" + headers['period'] + "--" + headers['task_util'] + "--" + headers['memory_util'] + "--" + headers['bandwidth'] + "--" + headers['ipc_size'] + "--" + headers['copy_dist']

def main():
    parser = argparse.ArgumentParser()
    # parser.add_argument('-d', "--datafile", type = argparse.FileType('w'),
                        # default = sys.stdout,
                        # help = "File to output csv file to")
    #parser.add_argument('-p', "--plot", action='store_true',
    #                    help = "For plotting generated PETs")
    #parser.add_argument('-m', "--processors", default=5, type = int,
    #parser.add_argument('-m', "--processors", default=cpu_count(), type = int,
    #                    help = "Number of processors to execute on")

    #args = parser.parse_args()
    exp = storage()

    if 1:
        exp.task_util = NAMED_UTILIZATIONS.keys()
        exp.period = NAMED_PERIODS.keys()
        exp.memory_util = NAMED_MEMORY.keys() #mem util is max reload time
        exp.util_dist = NAMED_UTIL_DISTS.keys()
        exp.sys_util = myrange(0.2, 9.0, 0.4)
    
        exp.ipc_size = NAMED_IPC_SIZES.keys()
        exp.bandwidth = NAMED_BANDWIDTHS.keys()
        exp.copy_dist = NAMED_COPY_DIST.keys()

    exp.num_graphs = NAMED_NUM_GRAPHS.keys()
    exp.depth_factor = NAMED_HEIGHT_FACTORS.keys()
    exp.node_placement = NAMED_SHAPES.keys()
    exp.fan_out = NAMED_FAN.keys()
    exp.edge_distance = NAMED_EDGE_HOP.keys()
    #exp.cross_crit = NAMED_CROSS_CRIT_COMMS.keys()

    #exp.qos = NAMED_QOS.keys()

    design_points_tmp = [dp for dp in DesignPointGenerator(exp, lambda x: True)]
    design_points = []

    donealready = os.listdir("../results_refined/")

    titles = []
    keyCounts = {}
    for key in exp:
        keyCounts[key] = {}
        for key2 in exp[key]:
            keyCounts[key][key2] = 0

    dp_i = 0
    while dp_i < len(design_points_tmp):
        dp = design_points_tmp[dp_i]
        title = titlefor(dp)
	if title not in donealready:
            if not title in titles:
                titles.append(title)
                for key in dp:
                    keyCounts[key][dp[key]] += 1

        dp_i += 1
    for key in keyCounts:
        print key
        for key2 in keyCounts[key]:
            print "\t",key2,"\t",keyCounts[key][key2]


if __name__ == '__main__':
    main()
